#include <iostream>
#include <cmath>
#define MAXN 30005
using namespace std;

int main()
{
    int t;
    cin>>t;

    for(int i=1;i<=t;i++)
    {
        int n;
        int a[MAXN],b[MAXN];
        int prvavrednost,indexprve,drugavrednost,indexdruge;
        cin>>n;
        for(int j=1;j<=n;j++)
            cin>>a[j];
        for(int j=1;j<=n;j++)
            cin>>b[j];

        for(int j=1;j<=n;j++){
            if(a[j]!=0) {
                prvavrednost=a[j];
                indexprve=j;
            }
            if(b[j]!=0)
            {
                drugavrednost = b[j];
                indexdruge = j;
            }
        }

        if(abs(drugavrednost)==abs(prvavrednost))
        {
                if(indexprve==indexdruge)
                {
                    if(drugavrednost==prvavrednost){
                        cout<<"DA"<<endl;
                    }
                    else {
                        cout<<"NE"<<endl;
                    }
                }
                if(indexprve>indexdruge){
                    if((indexprve-indexdruge)%2!=0){
                        if(drugavrednost!=prvavrednost){
                            cout<<"NE"<<endl;
                        }
                        else    {
                            cout<<"DA"<<endl;
                        }
                    }
                else
                {
                    if(drugavrednost==prvavrednost){
                        cout<<"NE"<<endl;
                    }
                    else    {
                        cout<<"DA"<<endl;
                    }
                }
            }
            else
            {
                    if((indexdruge-indexprve)%2==0){
                        if(drugavrednost!=prvavrednost){
                            cout<<"NE"<<endl;
                        }
                        else    {
                            cout<<"DA"<<endl;
                        }
                    }
                else
                {
                    if(drugavrednost==prvavrednost){
                        cout<<"NE"<<endl;
                    }
                    else    {
                        cout<<"DA"<<endl;
                    }
                }
            }


        }
        else
            cout<<"NE"<<endl;


    }
    return 0;
}